PCEP Extension for NRP-ID
Internet-Draft draft-xiong-pce-nrp-id-01
Quan Xiong
ZTE Corporation
No.6 Huashi Park Rd
Wuhan
Hubei
430223
China
xiong.quan@zte.com.cn
Shaofu Peng
ZTE Corporation
No.50 Software Avenue
Nanjing
Jiangsu
210012
China
peng.shaofu@zte.com.cn
Vishnu Pavan Beeram
Juniper Networks
vbeeram@juniper.net
Tarek Saad
Juniper Networks
tsaad@juniper.net
2022
Routing
PCE
This document proposes a set of extensions for PCEP to support the identifier of Network Resource Partition (NRP-ID) as the constraint of network slicing during path computation.
Introduction
[RFC5440] describes the Path Computation Element Protocol (PCEP) which is used between a Path Computation Element (PCE) and a Path Computation Client (PCC) (or other PCE) to enable computation of Multi-protocol Label Switching (MPLS) for Traffic Engineering Label Switched Path (TE LSP). PCEP Extensions for the Stateful PCE Model [RFC8231] describes a set of extensions to PCEP to enable active control of MPLS-TE and Generalized MPLS (GMPLS) tunnels. As depicted in [RFC4655], a PCE MUST be able to compute the path of a TE LSP by operating on the TED and considering bandwidth and other constraints applicable to the TE LSP service request. The constraint parameters are provided such as metric, bandwidth, delay, affinity, etc. However these parameters can't meet the network slicing requirements.
According to 5G context, network slicing is the collection of a set of technologies to support network service differentiation and meeting the diversified requirements from vertical industries. As defined in [I-D.ietf-teas-ietf-network-slice-definition], an IETF network slice is a logical network topology connecting a number of endpoints using a set of shared or dedicated network resources that are used to satisfy specific Service Level Objectives (SLOs). As defined in [I-D.ietf-teas-ietf-network-slices], a Network Resource Partition (NRP) is a collection of resources (bufferage, queuing, scheduling, etc.) in the underlay network to support the IETF Network Slice service (or any other service that needs logical network structures with required characteristics to be created). And as per [I-D.ietf-teas-ns-ip-mpls], NRP Identifier (NRP-ID) indicates an identifier that is globally unique within an NRP domain and that can be used in the control or management plane to identify the resources associated with the NRP. The NRP-ID could be used to identify the slice and network resource and viewed as constraints of network slicing when PCE is deployed. PCE MUST take the identifier of slicing into consideration during path computation.
This document proposes a set of extensions for PCEP to support the NRP-ID as the constraint of network slicing during path computation.
Conventions used in this document
Terminology
The terminology is defined as [RFC5440] and [I-D.ietf-teas-ietf-network-slice-definition].
Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
PCEP Extensions for Network Resource Partition
As defined in [RFC5440] , the LSPA object is used to specify the LSP attributes to be taken into account by the PCE during path computation such as constraints. This document proposes new TLV for the LSPA object to carry TE constraints for network slicing.
NRP-ID TLV
The NRP-ID TLV is optional and is defined to carry the slice specific constraint. PCEP message needs to carry NRP-ID to limit the network resources for path calculation within a NRP domain.
The format of the NRP-ID TLV is shown as Figure 1:
Figure 1: NRP-ID TLV

    0                   1                   2                   3
    0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |         Type=TBD1             |            Length=4           |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
   |                           NRP-ID                              |
   +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+

The code point for the TLV type is TBD1. The TLV length is 4 octets.
NRP-ID (32 bits): indicates a NRP Identifier as defined in [I-D.ietf-teas-ns-ip-mpls].
Protocol Operation
As defined in [I-D.ietf-teas-ns-ip-mpls], NRP state aware TE (NRP-TE) should implement the TE path selection that takes into account the available network resources associated with a specific NRP. The NRP-ID TLV should be carried in PCEP messages when computing NRP state aware TE paths. The PCE may maintain network resources per path and the NRP state within the resource pool identified by NRP-ID.
In a PCReq message, a PCC MAY request the PCC to compute the NRP-TE path and insert a NRP-ID TLV to indicate the resources within a NRP domain. The PCE will perform path computation based on the intra-domain or inter- domain sub-topology identified by the specific NRP-ID, that can be used to find the corresponding customized topology or referenced topology, and corresponding resources. The PCE may reply the PCC with NRP-ID TLV carried in PCRep message and the headend may insert the NRP-ID into an encapsulated data packet. In case of unsuccessful path computation when the NRP-ID constraint could not be satisfied, the the PCRep message may contain a NO-PATH object.
In a PCInit/PCUpd message, the PCE MAY compute the optimal NRP-TE path and carry the NRP-ID TLV so as to provide the network slicing information. If a PCC is unable to recognize a NRP-ID value passed in an LSP PCInit/PCUpd request, the PCC must keep the LSP in DOWN state, and include an LSP Error Code value of "Unsupported NRP" [Value to be assigned by IANA] in LSP State Report message.
Security Considerations
TBA
Acknowledgements
TBA
IANA Considerations
IANA is requested to make allocations from the registry, as follows:
Type | TLV | Reference
TBD1 | NRP-ID TLV | [this document]
Normative References
[RFC2119]

Key words for use in RFCs to Indicate Requirement Levels
S. Bradner
March 1997
BCP 14
RFC 2119
DOI 10.17487/RFC2119
[RFC5440]

Path Computation Element (PCE) Communication Protocol (PCEP)
JP. Vasseur, Ed.
JL. Le Roux, Ed.
March 2009
RFC 5440
DOI 10.17487/RFC5440
[RFC8174]

Ambiguity of Uppercase vs Lowercase in RFC 2119 Key Words
B. Leiba
May 2017
BCP 14
RFC 8174
DOI 10.17487/RFC8174
[RFC8231]

Path Computation Element Communication Protocol (PCEP) Extensions for Stateful PCE
E. Crabbe
I. Minei
J. Medved
R. Varga
September 2017
RFC 8231
DOI 10.17487/RFC8231
[RFC4655]

A Path Computation Element (PCE)-Based Architecture
A. Farrel
J.-P. Vasseur
J. Ash
August 2006
RFC 4655
DOI 10.17487/RFC4655
[I-D.ietf-teas-ietf-network-slice-definition]

Definition of IETF Network Slices
Reza Rokui
Nokia
Shunsuke Homma
NTT
Kiran Makhijani
Futurewei
Luis M. Contreras
Telefonica
Jeff Tantsura
Juniper Networks
22 February 2021
Internet-Draft draft-ietf-teas-ietf-network-slice-definition-01
[I-D.ietf-teas-ns-ip-mpls]

Realizing Network Slices in IP/MPLS Networks
Tarek Saad
Juniper Networks
Vishnu Pavan Beeram
Juniper Networks
Jie Dong
Huawei Technologies
Bin Wen
Comcast
Daniele Ceccarelli
Ericsson
Joel Halpern
Ericsson
Shaofu Peng
ZTE Corporation
Ran Chen
ZTE Corporation
Xufeng Liu
Volta Networks
Luis M. Contreras
Telefonica
Reza Rokui
Ciena
Luay Jalil
Verizon
16 June 2022
Internet-Draft draft-ietf-teas-ns-ip-mpls-00
[I-D.ietf-teas-ietf-network-slices]

Framework for IETF Network Slices
Adrian Farrel
Old Dog Consulting
John Drake
Juniper Networks
Reza Rokui
Ciena
Shunsuke Homma
NTT
Kiran Makhijani
Futurewei
Luis M. Contreras
Telefonica
Jeff Tantsura
Microsoft Inc.
30 June 2022
Internet-Draft draft-ietf-teas-ietf-network-slices-12